package com.madeu.controller.web.webappuser;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webappuser.WebAppUserService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebAppUserView;
import com.madeu.view.web.WebHolidayManagementView;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Controller
public class WebAppUserController extends ManagerDraftAction{

    @Autowired
    private WebAppUserService webAppUserService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 앱 회원 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappuser/selectListAppUserIntro.do")
    public String  selectListAppUserIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebAppUserController  selectListAppUserIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppUserService.selectListAppUserIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppUserController selectListAppUserIntro END");
        return "/web/appuser/appUserSelectList";
    }

    /**
     * 앱 회원 정보 리스트 조회 (List)
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappuser/selectListAppUser.do")
    public ModelAndView selectListAppUser(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebAppUserController selectListAppUser START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webAppUserService.selectListAppUser(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebAppUserController selectListAppUser END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * <b>앱 회원 정보 엑셀 다운로드 </b>
     * 페이지 처리 없음
     * request:
     * response : msgCode, msgDesc
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webappuser/downloadAppUserExcel.do")
    public ModelAndView downloadAppUserExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
        log.debug("WebAppUserController downloadAppUserExcel START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        List<Map<String, Object>> selectListReport = new ArrayList<Map<String,Object>>();
        Map<String, Object> map = new HashMap<String,Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                selectListReport = webAppUserService.selectListAppUserExcel(paramMap);
                map.put("selectListAppUser", selectListReport);
                map.put("name", "AppUser");
            }
        }
        catch(Exception e){
            e.printStackTrace();
            return null;
        }
        log.debug("WebAppUserController downloadAppUserExcel END");
        return new ModelAndView(new WebAppUserView(),"map",map);
    }
}

